#include <string.h>
#include "filewrappers.h"

char *ConvertC2P(char *src)			//This breaks if you run it over a C string.
{
	long	i, j;
	char	*dst;
	
	
	for(i = 0; src[i] != NULL; i++)	//How many characters do we have?
	{}
	
	j = i++; //It only counted up to (not including) the last character.
		
	strcpy(src, dst);	//We don't want to alter the source string.
	
	while(--i)	//It's easier and faster to run backwards.
	{
		dst[i] = src[i - 1];	//Offset the character by one to make room.
	}
	
	dst[0] = j;	//First character is \p (the number of subsequent characters)
	
	return dst;	//Our finished string.
}

void FileClose(int fd)	//A wrapper for close().
{
	FSClose(fd);
}

long FileRead(int fd, char *buffer, long length)	//A wrapper for read().
{
	OSErr	err;
	
	err = FSRead(fd, &length, buffer);
	
	if(err == 0 || -39)	//These two are noErr and EOF (not an error per se)
	{
		return length;
	} else {	//We had a real error.
		return 0;
	}
}

long FileWrite(int fd, char *buffer, long length)	//A wrapper for write().
{
	OSErr	err;
	
	err = FSWrite(fd, &length, buffer);
	
	if(err == 0 || -39)	//See FileRead() for error descriptions.
	{
		return length;
	} else {
		return 0;
	}
}

void FileSetPos(int fd, long pos)	//A wrapper for setpos();
{
	SetFPos(fd, fsFromStart, pos);
}